#!/bin/bash

echo TODO pulire dati, grafici strani

/bin/rm -f Grafici/*gif Grafici/*png

#shopt -u nocaseglob
#shopt -u nocasematch
#shopt |grep case

plotta()
{
PLOTCOMMAND=""
#for file in CSV/Milano*.csv
for file in $FILES
do
 #echo $file
 FIELD=$(head -n 1 $file|cut -f$FIELDNUM -d,)
 TITLE=$(basename $file .csv):$FIELD
 LIMITE=$(grep $FIELD limiti.txt|cut -f2 -d=)
 PLOTCOMMAND="'$file' using 1:$FIELDNUM with lines title '$TITLE', $PLOTCOMMAND"
 #PLOTCOMMAND="'$file' using 1:limita($FIELDNUM,$LIMITE) with lines title '$TITLE', $PLOTCOMMAND"
 #PLOTCOMMAND="'$file' using 1:$FIELDNUM with lines title '$TITLE', $PLOTCOMMAND"
done

FILENAME=$FIELD"_"$(echo $DATAINIZIO|tr "/" "-")"_"$(echo $DATAFINE|tr "/" "-")
echo Filename: $FILENAME, Inizio: $DATAINIZIO, Fine: $DATAFINE

PLOTCOMMAND=$(echo $PLOTCOMMAND|rev|cut -c2-|rev)
echo $PLOTCOMMAND

#gnuplot -persistent <<PLOT
gnuplot <<PLOT

# cfr. http://theochem.ki.ku.dk/on_line_docs/gnuplot/gnuplot_16.html

set terminal png size 800,600 large
set output "$FILENAME.png"
#set output prova.gif

set xdata time

set xtics rotate by -90 font "Helvetica,10"
#set xtics autofreq

set timefmt "%Y/%m/%d"
set xrange ["$DATAINIZIO":"$DATAFINE"]
#set xrange ["2011/01/01":"2012/06/31"]
#set xrange ["2005/01/01":"2012/06/31"]
set format x "%Y/%m/%d"
set timefmt "%Y/%m/%d"

#lim=$LIMITE*3
#set yrange [0:200]
set ytics 10

# da pyxplot
#plot '[A-Z]*.csv' with lines using time_julianday($1,$2,$3,12,0,0):5  select $5<200 and $5>0 and $1>2009
#plot '[A-Z]*.csv' with lines using 5  select $5<200 and $5>0 and $1>2009


##################################################
#moving average
#http://gnuplot.sourceforge.net/demo_cvs/data_feedback.html
samples(x) = \$0 > 2 ? 3 : (\$0+1)
avg3(x) = (shift3(x), (back1+back2+back3)/samples(\$0))
shift3(x) = (back3 = back2, back2 = back1, back1 = x)
# Initialize a running sum
#
init(x) = (back1 = back2 = back3 = back4 = back5 = sum = 0)
##################################################



#set key right bottom
set key font ",6"

set datafile missing ' '
set datafile separator ','

#set multiplot

pioggia(x) = (x > 3 ? 100 : 0)

limita(x,l) = (x > l ? l : x)

plot sum=init(0),\
	$PLOTCOMMAND,\
	$LIMITE title "riferimento $FIELD=$LIMITE"

#	'CSV/pioggia.csv' using 1:(avg3(pioggia(\$2))) with lines title "pioggia nei 3 gg prec.",\
#	'CSV/pioggia-permese.csv' using 1:(\$2*3) with lines title "%gg pioggia nel mese",\


#  select $5<200 and $5>0 and $1>2009

#pause -1
PLOT
}

################################################
### solo pm10 per fare confronti areac (set-lug)
### no dentro-fuori
for anno in 2010 2011 2012 2013
do
 DATAINIZIO=$anno/09/01
 let anno=anno+1
 DATAFINE=$anno/07/31
 FIELDNUM=3
 FILES="CSV/Milano*.csv"
 plotta
done

################################################
### tutti (dentro-fuori)
for inqui in 3 4 5 6 7 8
do
 # dal 2008
 DATAINIZIO=2008/01/01
 DATAFINE=$(date +%Y/%m/%d)
 FIELDNUM=$inqui
 FILES="CSV/Milano*.csv CSV/Limit*"
 plotta

 # 2 anni indietro
 DATAINIZIO=$(date +%Y/%m/%d|sed 's/2014/2012/g')
 DATAFINE=$(date +%Y/%m/%d)
 FIELDNUM=$inqui
 FILES="CSV/Milano*.csv CSV/Limit*"
 plotta

 # 1 anno indietro
 DATAINIZIO=$(date +%Y/%m/%d|sed 's/2014/2013/g')
 DATAFINE=$(date +%Y/%m/%d)
 FIELDNUM=$inqui
 FILES="CSV/Milano*.csv CSV/Limit*"
 plotta

 # 1 mese indietro
 DATAINIZIO=$(date +%Y/%m/%d|awk -F/ '{printf "%d/%2d/%d",$1,$2-1,$3}'|tr " " "0")
 DATAFINE=$(date +%Y/%m/%d)
 FIELDNUM=$inqui
 FILES="CSV/Milano*.csv CSV/Limit*"
 plotta
done


mv *png Grafici



exit
####################
#dentro fuori
DATAINIZIO=2011/09/01
DATAFINE=$(date +%Y/%m/%d)
FIELDNUM=3
FILES="CSV/Milano*.csv CSV/Limit*"
plotta

DATAINIZIO=2014/01/01
DATAFINE=$(date +%Y/%m/%d)
FIELDNUM=3
FILES="CSV/Milano*.csv CSV/Limit*"
plotta

DATAINIZIO=2013/09/01
DATAFINE=$(date +%Y/%m/%d)
FIELDNUM=4
FILES="CSV/Milano*.csv CSV/Limit*"
plotta

DATAINIZIO=2014/01/01
DATAFINE=$(date +%Y/%m/%d)
FIELDNUM=4
FILES="CSV/Milano*.csv CSV/Limit*"
plotta

#DATAINIZIO=2011/01/01
#DATAFINE=2012/06/31
#FIELDNUM=3
#plotta
######################################





exit
#########################
# piovosita'
pushd CSV
cat piovosit*csv |sort|uniq|grep -v LOCALIT|cut -f2,15 -d';' | sort -n -t "/" --key=3 --key=2 --key=1 |awk -F';' 'split($1,data,"/") {print data[3]"/"data[2]"/"data[1]","length($2)}' > pioggia.csv

for anno in $(seq 2005  2012)
do
 #grep $anno pioggia.csv > pioggia-$anno.csv
 for mese in $(seq 1 12)
 do
  echo -n $anno/$mese/27,
  grep "^$anno/$mese/" pioggia.csv |cut -f2 -d, |awk '{if($1 >3) print $1}' |wc -l
 done  #> pioggia-$anno-permese.csv
done > pioggia-permese.csv


popd
#########################
